import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;

/**
 * Write a description of class InfoSign here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class InfoSign  extends Actor
{
    boolean opened = false;
    boolean closing = false;
    int width = 10; int height = 10;
    GreenfootImage img;
    /**
     * 
     */
    public void act() 
    {
        // Add your action code here.
        if (!opened && !closing) {
            open();
        } 
        if (closing) {
            close();
        }
    }    
    
    public void startClosing() {
        closing = true;
    }
    
    public void makeSureThisOpens() {
        closing = false;
        opened = false;
    }
    
    public void open() {
        img = new GreenfootImage(width,height);
        img.drawRect(0,0,width-1,height-1);
        if (height < 190) {
            height += 10;  
        } else if (width < 210) {
            width += 10; // turns out 200 is a little too small!  Make it 210!
        } else {
            img.setColor(Color.WHITE);
            img.fillRect(0,0,width-1,height-1);
            img.setColor(Color.BLACK);
            img.drawRect(0,0,width-1,height-1);
            //getWorld().setPaintOrder(InfoSign.class,DialPart.class,Arrow.class,Dial.class);
            img.drawString("The variables are only meant to ",10,15);
            img.drawString("merely simulate a slingshot.  They ",10,30);
            img.drawString("are really just arbitrary numbers",10,45);
            img.drawString("and they do not correlate to one",10,60);
            img.drawString("another the same way as they do in ",10,75);
            img.drawString("real life. Warning: Don't use this to ",10,90);
            img.drawString("try to devolop a working intuition",10,105);
            img.drawString("of how an elastic launching  ",10,120);
            img.drawString("mechinism exactly responds to ",10,135);
            img.drawString("changes in mass in the real world,",10,150);
            img.drawString("or anything like that, because ",10,165);
            img.drawString("it's a little different. ",10,180);
            opened = true;
        }
        setImage(img);
    }
    
    public void close() {
        img = new GreenfootImage(width,height);
        img.drawRect(0,0,width-1,height-1);
        opened = false;
        if (height > 20) {
            height -= 10;
        } else if (width > 20) {
            width -= 10;
        } else {
            getWorld().removeObject(this);
            closing = false;
        }
        setImage(img);
    }
}
