import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;
import java.awt.Font;
import java.util.ArrayList;
import java.util.Timer;
import java.util.TimerTask;

/**
 * Wasn't sure how to go about this, so I decided to sit down and write my own.  The Inputbox
 * lets you input a number.  It has a label, a range, and a fuction to retrieve the number
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class InputBox extends Actor
{
    String input; // user input!
    String label; // title of the InputBox!
    Font font; // gotta have a font!
    double min, max; // the minimum and maximum input
    int size; // the size of the text box
    ArrayList<Character> numbers = new ArrayList();
    boolean active; // is the Inputbox taking input right now?
    Timer t; // a timer! 
    boolean waitasec = false; // get set to true when a timer is needed
    double finalnum; // the double form of the input, this is what gets returned in returnInput()
    int boxtype; // because I don't know how to program events, so I just send the boxtype back to testworld to let it
                 // know how to interpet the message
    TestWorld tstwrld;  // gotta have a pointer to the testworld!
    boolean initialized = false;
    boolean sendinfo = false; // Yet another boolean...
    
    public InputBox(String title, double minimum, double maximum, double thedefault, int howbig, int boxnum) {
        label = title;
        min = minimum;
        max = maximum;
        size = howbig;
        input = Double.toString(thedefault);
        //tstwrld = (TestWorld) getWorld();  // ok to put in constructor.  I think.
        boxtype = boxnum;
    }
    
    /**
     * Act - do whatever the InputBox wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        // Get a pointer to the testworld
        if (!initialized) {
            tstwrld = (TestWorld) getWorld();
            initialized = true;
        }
        checkIfActive(); // checks whether or not the input box is active(if it has been clicked on)
        if (active) {
            getInput(); // gets input from the keyboard
        }
        setInput(); // checks input for errors, and sets the numbers up right
        show();// draws the inputbox
        int inc = 0;
    } 
    
    /**
     *  This is the method which returns the user input!!  I suppose I could have made this Input box send out events,
     *  and make The world a registered event listener, but I didn't want to learn how do do all that right at the moment.
     *  So I just build a method into testworld that makes the approperate changes depending on the boxtype!
     */
    public void returnInput() {
        tstwrld.getInput(boxtype, finalnum);
    }
    
    public double whatIsInput() {
        return finalnum;
    }
    
    public void setInput() {
        double tempnum;
        if (input.length() > 0) {
            tempnum = Double.parseDouble(input);
        } else {
            tempnum = 0;
        }
        // make sure it is within the correct bounds
        if (finalnum < min) {
            tempnum = min;
        } 
        if (finalnum > max) {
            tempnum = max;
        }
        if (!active) {
            finalnum = tempnum; // Don't mess with the input until the user indicates he is done enterint input
            // by making the inputbox non active
            input = Double.toString(finalnum); // make the input into a double
            if (sendinfo) {
                returnInput(); // this is the method that tells TestWorld to handle the user input.
                // only do this once
                sendinfo = false;
            }
        }
    }
    
    public void getInput() {      
            if (Greenfoot.isKeyDown("backspace")) {
                // erase the last character from input
                // how should I do this...convert to an array..except for the last letter, and then convert bac
                // to a string...
                if (input.length() >= 1) {
                    char[] carray = new char[input.length()-1];
                    for (int i = 0; i < input.length()-1; i++) {
                        carray[i] = input.charAt(i);
                    }
                    input = new String(carray); Greenfoot.delay(1);
                }
            
            } else {
                // I wish I knew a cleaner way to do this!
                if (Greenfoot.isKeyDown("0")) {
                    addLetter("0");
                } else if (Greenfoot.isKeyDown("1")) {
                    addLetter("1");
                } else if (Greenfoot.isKeyDown("2")) {
                    addLetter("2");
                } else if (Greenfoot.isKeyDown("3")) {
                    addLetter("3");
                } else if (Greenfoot.isKeyDown("4")) {
                    addLetter("4");
                } else if (Greenfoot.isKeyDown("5")) {
                    addLetter("5");
                } else if (Greenfoot.isKeyDown("6")) {
                    addLetter("6");
                } else if (Greenfoot.isKeyDown("7")) {
                    addLetter("7");
                } else if (Greenfoot.isKeyDown("8")) {
                    addLetter("8");
                } else if (Greenfoot.isKeyDown("9")) {
                    addLetter("9");
                } else if (Greenfoot.isKeyDown(".")) {
                    // ONLY ONE DOT ALLOWED!  CHECK FOR DOTS FIRST
                    int inc = 0;
                    boolean hasadot = false;
                    for (int i = 0; i < input.length(); i++ ) {
                        if (input.charAt(i) == '.') {
                            hasadot = true;
                        }
                        else {
                            inc++; // count how many non dots there are
                        }
                    }
                    if (inc == input.length()) {
                        hasadot = false;
                    }
                    if (!hasadot) {
                        addLetter(".");
                    }
                }
            }
    }
    /**
     * If you press a key, it checks isKeyDown 10^213467988 times a second.  This is to make sure that if you hold
     * a key down, it repeats at a reasonable rate.
     */
    public void addLetter(String letter) {
        // first check to see if input has a length. IF SO check to see what the previous key was
        if (input.length() >= 1) {
            // alright. Now compare the new letter to the previous one
            if (letter.charAt(0) == input.charAt(input.length()-1)) { 
                // the letter is the same.  So what can we do?  Wait a second, then add it if the key is still down
                // Only set the timer off once.  Make it impossible to reset, until that one goes off.
                if (!waitasec) {
                    t = new Timer();
                    t.schedule(new WaitForIt(letter),180);  // tried a couple values.  150 too fast, 200 to slow, 180 is ok
                    waitasec = true;
                } 
                // almost works. still one problem.  If the key gets released, and then pushed again, it takes a split
                // second (.18 secs) to appear.  I don't know how to get around this though!  WORKS GOOD ENOUGH FOR NOW no need to
                // spend forever trying to fix a minor bug I have no idea how to fix!!
                
            } else { 
                // the letter is different. simply concat the letter
                input = input.concat(letter);
            }
        } else {
            // the string is empty.  Add the letter
            input = input.concat(letter);
        }
        // if input is "." there is a runtime error.  So make sure it doesn't equal this
        if (input.equals(".")) {
            input = "0.";
        }
    }
    /**
     * This method draws the inputbox with the string and everything
     */
    public void show() {
        // the size of the box is controlled by the variable size..
        GreenfootImage img = new GreenfootImage(size*8,size+25);
        // draw a box.  This took a couple tries before it worked 
        if (active) {
            img.setColor(Color.RED);
        }
        img.drawRect(0,20,size*8-1,size+10-1);
        img.drawRect(0,0,img.getWidth()-1,img.getHeight()-1);
        // draw the label
        img.setColor(Color.BLACK);
        img.drawString(label,5,15);
        // draw the input
        font = img.getFont();
        float f = size;
        font = font.deriveFont(f);
        img.setFont(font);
        img.drawString(input,5,img.getHeight()-5);
        // draw the image
        setImage(img);
    }
    
    public void drawCursor() {
    }
    
    class WaitForIt extends TimerTask {
        String l;
        public WaitForIt(String theLetter) {
            l = theLetter;
        }
        public void run() {
            if (Greenfoot.isKeyDown(l)) {
                input = input.concat(l);
            }
            waitasec = false; // make it possible for the outer class to create another timer
        }
    }
    
    public void checkIfActive() {
        // pretty simple...check to see if the mouse has been pressed on this.
        if (Greenfoot.mousePressed(null)) {
            if (Greenfoot.mousePressed(this)) {
                active = true;
                sendinfo = true; // get tje box ready to send info...
                tstwrld.Pause(); // pause the program
            } else {
                active = false;
                tstwrld.unPause();
            }
        }
    }
}
