import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;

/**
 * Write a description of class SimpleTarget here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class SimpleTarget  extends Actor
{
    int initialx, initialy;
    Color[] colors = {Color.RED,Color.GREEN,Color.BLUE,Color.BLACK,Color.ORANGE,Color.WHITE,Color.YELLOW};
    int color;
    int direction; // this number just determines whether or not it's floating right or left
    int floatspeed;
    int width,height;
    boolean locationset = false;
    boolean knockedpelletback = false;  // only knock the pellet back once
    Pellet p;
    int pelletid;
    GreenfootImage img;
    TestWorld t;
    public SimpleTarget() {
        // set an initial position
        int negitiveorpositive;
        if (Greenfoot.getRandomNumber(2) == 1) {
            negitiveorpositive = -1;
        } else {
            negitiveorpositive = 1;
        }
        direction = negitiveorpositive*(Greenfoot.getRandomNumber(3) + 1);
        floatspeed = Greenfoot.getRandomNumber(2) + 1;
        width = Greenfoot.getRandomNumber(20) + 20;
        height = Greenfoot.getRandomNumber(20) + 20;
        img = new GreenfootImage(width,height);
        drawImg(false);
    }
    /**
     * So the target just kinda floats around 
     */
    public void act() 
    {
        // Add your action code here.
        if (!locationset) {
            initialx = Greenfoot.getRandomNumber(getWorld().getWidth()/2) + getWorld().getWidth()/2;
            initialy = getWorld().getHeight();
            setLocation(initialx,initialy);
            t = (TestWorld) getWorld();
            locationset = true;
        }
        p = (Pellet) getOneIntersectingObject(Pellet.class);
        if (p != null) {
            //pellitid x = p.hashCode();
            // the problem is how does one prevent multiple collisions from the same pellet?
            // think I'll try using the hashCode!!
            if (p.hashCode() != pelletid) {
                pelletid = p.hashCode();
                drawImg(true);
                t.displayCollisionData(p.getAngle(), p.getVelocity(),p.getX(),p.getY());
                if (direction < 0) {
                    direction = direction*(-1); // if we get hit, change direction
                }
                //if (!knockedpelletback) {
                    knockedpelletback = true;
                    p.knockBack();
                    //t.displayCollisionData(p.getAngle(), p.getVelocity);
                //}
            }
            /*drawImg(true); // setting to true makes sure the color gets changed from whatever it was
            if (direction < 0) {
                direction = direction*(-1); // if we get hit, change direction
            }
            // do this before we do anything to the pellet!
            t.displayCollisionData(p.getAngle(), p.getVelocity());
            if (!knockedpelletback) {
                    knockedpelletback = true;
                    p.knockBack();
                    //t.displayCollisionData(p.getAngle(), p.getVelocity);
             }
             //t.displayCollisionData(p.getAngle(), p.getVelocity());*/
        }

        setLocation(getX() + direction,getY() - floatspeed);
        if (Greenfoot.getRandomNumber(50) == 1) {
            changeDirection();
        }
        
        if (getY() <= 1) {
            getWorld().removeObject(this);
        }
    }  
    
    public void drawImg(boolean colorchange)
    {
        if (colorchange) {
            color = Greenfoot.getRandomNumber(7);
        } else {
            boolean keepdoingthis = true;
            int rand;
            while(keepdoingthis) {
                rand = Greenfoot.getRandomNumber(7);
                if (rand != color) {
                    keepdoingthis = false;
                    color = rand;
                }
            }
        }
        Color thecolor = colors[color];
        img.setColor(thecolor);
        img.fillRect(0,0,width,height);
        img.setColor(Color.BLACK);
        img.drawRect(0,0,width-1,height-1);
        setImage(img);
    }
    
    public void changeDirection() {
        direction = direction*(-1);
    }
}
